# ..parallax for bitchx
# ..code by shade (sk@lm.com)

# ..dict server lookup
alias dict { 
  if ([$*]) {
    @ dict_str = filter(-% $*), dict_flags = pattern(-% $*)
    @ dict_db = dict_flags =~ [*d*] ? shift(dict_str) : [*]
    @ dict_fd = opensocket($dict_server 2628)
    ^on ^socket '$dict_fd 2628 $dict_server *' {
      switch ($3) {
      (220) {   
        @ writesocket($dict_fd ${dict_flags =~ [*l*] ? [show db] : [define $dict_db \"$dict_str\"]})}
      (552) {
        ce no match for your query.
        @ writesocket($dict_fd quit)}
      (150) {
        ce $4 definition$plural($4) retrieved.}
      (151) {
        ${dict_flags =~ [*o*] ? [say] : [ce]} from $6-
        @ _ae = 1}
      (250) {
        @ writesocket($dict_fd quit)}
      (110) {
        ${dict_flags =~ [*o*] ? [say] : [ce]} $4-
        @ _ae = 1}
      (550) {
        ce $dict_db is an invalid database. try /dict -l for a list.
        @ writesocket($dict_fd quit)}
      (221) {
        @ closesocket($dict_fd), dict_str = dict_fd = dict_flags = dict_db = _ae = []
        ^on ^socket -"$dfd 2628 $dict_server *"}
      (.) {
        @ _ae = 0}
      (*) {
        if (_ae) {
          ${dict_flags =~ [*o*] ? [say] : [ce]} $3-}}}}} else {
    pusage dict}}
 
# ..unix commands
alias grep less_pipe grep $*

alias dwhois exec whois $*

alias ls exec ls -C${[$*]?[ $*]:}

alias more {
  @ fexist($remw(-r $*)) == 1 ? less_pipe(${[$0] == [-r] ? [tac $1-] : [cat $0-]}) : ce($remw(-r $*) does not exist.)}
alias less more $*

alias uname exec $0 uname -a

# ..hop's less_pipe with improvements
alias less_pipe {
  @ delarray(lessline)
  if ([$*]) {
    @ :pid = rand(23)
    ^on ^exec "$pid *" {
      @ setitem(lessline $numitems(lessline) $1-)}
    ^on ^exec_error "$pid *" {
      xecho -b $*}
    ^on ^exec_exit "$pid *" {
      on exec -"$pid *"
      on exec_error -"$pid *"
      on exec_exit -"$pid *"
      less_array lessline 0}
    exec -name $pid $*}}

alias less_array {
  @ array_name = [$0], _line = [$1], _size = 0
  until (_size >= winsize() || _line == numitems($0)) {
    echo $getitem($0 $_line)
    @ _size += numlines($getitem($0 $_line)), _line++}
  unless (_line == numitems($0)) {
    input_char "-> any key more more, q to quit. " unless ([$0] == [q]) {
      less_array $array_name $_line}}
  @ _readinglog ? _prompt_eraselog() :}

# ..dcc statistics
on ^dcc_header * {
  echo $box_header()
  echo $box_echo_head(%K[%c#%K] %c$numdots(8 type) %c$numdots(10 nick) %c$numdots(50 status)%n)}

on ^dcc_stat * {
  echo $box_echo(%K[%c$0%K] %n$numdots(8 $sar(g/raw_listen/listen/$1)) %n$numdots(10 $2) %n$numdots(50 $3))}

on ^dcc_statf * {
  @ _ds_num   = [$0]
  @ _ds_type  = [$1]
  @ _ds_nick  = [$2]
  @ _ds_stat  = [$3]
  @ _ds_speed = [$4]
  @ _ds_file  = [$5]}

on ^dcc_statf1 * {
  echo $box_echo(%K[%c$_ds_num%K] %n$numdots(8 $_ds_type) %n$numdots(10 $_ds_nick) ${_ds_stat == [Active] ? [%n$numdots(15 $sar(g$HOME~$_ds_file)) $percentbar($0) %n$fixsize($1)%K/%n$fixsize($2) %neta: ${strlen($4) == 1 ? [$3\:0$4] : [$3:$4]}%n] : numdots(50 $_ds_stat)})
  @ _ds_num = _ds_type = _ds_nick = _ds_stat = _ds_speed = _ds_file = []}

on ^dcc_post * {
  echo $box_footer()}

on ^dcc_transfer_stat * {
  echo $box_header()
  echo $box_echo_head(%cdcc transfer stats%n..)
  echo $box_echo($numdots(10 incoming)%n $numdots(10 $_fixsize($0)) %m\(%nmax%K:%n $1kb/s, min%K:%n $2kb/s%m\)%n)
  echo $box_echo($numdots(10 outgoing)%n $numdots(10 $_fixsize($3)) %m\(%nmax%K:%n $4kb/s, min%K:%n $5kb/s%m\)%n)
  echo $box_echo($numdots(10 total)%n $numdots(10 $_fixsize(${[$0]+[$3]})) %m\(%n$6 files%m\)%n%C%c $numdots(10 active)%n $7 %C%c $numdots(10 limit)%n $8)
  echo $box_footer()}
  
# ..notify notes v2
alias note {
  if (ismask($0) && [$1-] && match($before(! $0) $notify(-))) {
    @ setitem(notes1 $numitems(notes1) $0), setitem(notes2 $numitems(notes2) \($strftime(%D)@$fixtime($time())\: parallax notify note\) $1-)
    ce notify note for \"$0\" now pending delivery.} elsif (match($before(! $0) $notify(+))) {
    ce \"$before(! $0)\" is online, why not try /msg instead? \;>} elsif (!match($before(! $0) $notify())) {
    ce \"$before(! $0)\" is not on your notify list.} else {
    pusage note}}

alias notelist {
  if (numitems(notes1)) {
    echo $box_header()
    echo $box_head_echo(%cnotify notes pending delivery..%n)
    for (@ xx = 0, xx < numitems(notes1), @ xx++) {
      echo $box_echo(%n$numdots(30 $getitem(notes1 $xx)) %n$getitem(notes2 $xx))}
    echo $box_footer()} else {
    ce no notify notes are pending delivery.}}

alias unnote {
  if ([$*]) {
    if (:xx = rmatchitem(notes1 $0) > -1) {
      ce notify note for \"$getitem(notes1 $xx)\" has been deleted.
      @ delitem(notes1 $xx), delitem(notes2 $xx)} else {
      ce no notify note for \"$0\" is pending.}} else {
    pusage unnote}}

# ..ftp fixups
on ^ftp * {
  echo $cparse("$ftp_prompt") $2-
  @ [$1] == 200 ? addtab(/m -$0) :
  if ([$1] == 221) {
    fe ($revw($getmatches(tabs % /m -$0))) xx {
      @ delitem(tabs $xx)}}}

on #-input 23 "/m% -% *" {
  addtab /m $1}

alias ftp {
  if ([$0] == [-n] && (:xx = getuhost($1))) {
    //ftp $after(@ $xx) $2-} elsif ([$*]) {
    //ftp $*} else {
    pusage ftp}}

# ..userlist crap
alias friend {
  if ([$*]) {
    adduser -ppp $0 * friend,dcc,flood $1-} else {
    pusage friend}}

alias friend2 {
  if ([$*]) {
    adduser -ppp $0 * voice,unban,invite,dcc,flood $1-} else {
    pusage friend2}}

alias shit {
  if ([$*]) {
    addshit $0 * 3 $strftime(%D)@$fixtime($time())\: ${[$1] ? [$1-] : [shitlisted.]}} else {
    pusage shit}}

# ..editing commands
alias fedit {
  if (:xx = word(0 $pattern($0% $__fsets))) {
    type /fset $xx $($xx)} elsif ([$*]) {
    ce \"$0\" is not a valid fset.} else {
    pusage fedit}}

# ..addon stuff
alias addon {
  if (format_version =~ [*$*\*]) {
    ^fset format_version $format_version + $*}}

alias addfset {
  push _fsets $0
  @ __fsets = sort($tolower($getfsets() $_fsets))}

alias addset {
  push _sets $0
  @ __sets = sort($tolower($getsets() $_sets))}

alias addhelp {
  if (fexist($0) == 1) {
    @ :fd = open($* R) 
    until (eof($fd)) {
      @ :helpline = read($fd)
      switch ($[1]helpline) {
      (@) {
        @ _htype = after(@ $helpline)
        @ delarray(pu_$_htype), delarray(ph_$_htype)}
      (&) {
        @ setitem(pu_$_htype $numitems(pu_$_htype) $after(& $helpline))}
      (.) {
        @ setitem(ph_$_htype $numitems(ph_$_htype) $after(. $helpline))}}}
    @ close($fd)}}

# ..help alias
alias phelp {
  if ([$*] == [index] |! [$*]) {
    @ :ph_topics = sort($sar(g/ph_//$pattern(ph_% $tolower($getarrays()))))
    echo $box_header()
    echo $box_echo_head(help is available on the following topics%K: %m\(%n/phelp %K[%ntopic%K]%m\)%n)
    fe ($ph_topics) _ph1 _ph2 _ph3 _ph4 _ph5 {
      echo $box_echo($[12]_ph1 $[12]_ph2 $[12]_ph3 $[12]_ph4 $[12]_ph5)}
    echo $box_footer()} elsif (numitems(ph_$0)) {
    echo $box_header()
    echo $box_echo_head(help for %W$0%n%K..%n)
    for (@ xx = 0, xx < numitems(ph_$0), @ xx++) {
      echo $box_echo($getitem(ph_$0 $xx))}
    echo $box_footer()} else {
    ce no help is available for "$0".. try /phelp index.}}

# ..lastlog search
alias lastlog {
  if ([$0] == [-find] && [$1-]) {
    for (@ xx = lastlog, xx > 0, @ xx--) {
      @ stripansicodes($line($xx)) =~ [*$1-*] ? setitem(lls $numitems(lls) $xx $line($xx)) :}
    for (@ xx = 0, xx < numitems(lls), @ xx++) {
      echo $cparse("%K[%c$word(0 $getitem(lls $xx))%K]%n") $restw(1 $getitem(lls $xx))}
    @ delarray(lls)} else {
    //lastlog $*}}

# ..message fakers
alias frelm {
  if ([$1-]) {
    if (:xx = getuhost($0)) {
      say $fparse(format_msg ! $0 $xx $1-)} else {
      xecho -b \"$0\" is not on IRC.}} else {
    pusage frelm}}

alias freln {
  if ([$1-]) {
    if (:xx = getuhost($0)) {
      say $fparse(format_notice ! $0 $xx $1-)} else {
      xecho -b \"$0\" is not on IRC.}} else {
    pusage freln}}

alias rctcp {
  if ([$1]) {
    quote NOTICE $0 :$toupper($1) $2-
    ce faked CTCP $toupper($1)\: $2- sent to $0\.} else {
    pusage rctcp}}

# ..a better /orignick!
alias orignick {
  if (__nix) {
    ^on -channel_signoff -'% \\[$__nix\\] *'
    ^on -channel_nick -'% \\[$__nix\\] %'
    timer -del nick
    @ __nix = []
    ce orignick has been cancelled.} elsif ([$*]) {
    @ __nix = sar(g!-a!a b c d e f g h i j k l m n o p q r s t u v w x y z!$split(, $*))
    ce attempting to claim nick$plural($#__nix) [$sar(g!a b c d e f g h i j k l m n o p q r s t u v w x y z!a..z!$__nix)]..
    ^on -channel_nick '% \\[$__nix\\] %' {
      __orignick_cleanup}
    ^on -channel_signoff '% \\[$__nix\\] *' {
      __orignick_cleanup}
    ^on -server_notice_kill '% % \\[$__nix\\] *' {
      __orignick_cleanup}
    ^on -notify_signoff_uh '\\[$__nix\\] *' {
      __orignick_cleanup}
    __orignick} else {
    pusage orignick}}

alias __orignick_cleanup {
  ce claimed nickname \"$0\".
  //nick $0
  timer -del nick
  ^on -channel_nick -'% \\[$__nix\\] %'
  ^on -channel_signoff -'% \\[$__nix\\] *'
  ^on -server_notice_kill -'% % \\[$__nix\\] *'
  ^on -notify_signoff_uh -'\\[$__nix\\] *'
  @ __nix = []}

alias __orignick {
  if ((:anicks = diff($__nix / $getison($__nix))) && isconnected()) {
    ce claimed nickname \"$word(0 $anicks)\".
    //nick $word(0 $anicks)
    if (#anicks > 1) {
      ce also available: [$restw(1 $anicks)].}
    ^on -channel_nick -'% \\[$__nix\\] %'
    ^on -channel_signoff -'% \\[$__nix\\] *'
    ^on -server_notice_kill -'% % \\[$__nix\\] *'
    ^on -notify_signoff_uh -'\\[$__nix\\] *'
    @ __nix = []} elsif (__nix) {
    timer -ref nick $orignick_time __orignick}}

# ..make /nick better
alias nick {
  switch ($0) {
  (-ag) (-ao) (-ga) (-oa) {
    orignick -a}
  (-o) (-g) {
    orignick $1}
  (-r) {
    //nick $randomnick()}
  (-a) {
    if (:anicks = diff(a b c d e f g h i j k l m n o p q r s t u v w x y z/$getison(a b c d e f g h i j k l m n o p q r s t u v w x y z))) {
      //nick $word(0 $anicks)} else {
      xecho -b no alphabet nicks are available.}}
  (-f) {
    //nick $reverse($N)}
  (-s) {
    //nick $rest(1 $N)$left(1 $N)}
  (-c) {
    //nick $cool($N)}
  (-x) {
    if (hold_nickname) {
      //nick $hold_nickname}}
  () {
    pusage nick}
  (*) {
    //nick $*}}}

# ..rewrite of psy's /lj from argon
alias lj {
  @ :chan = ischannel($rightw(1 $*)) ? rightw(1 $*) : C
  if (:nick = getitem(lj_$chan 0)) {
    switch ($0) {
    (o) (-o) (+v) {   
      quote mode $chan +o $nick}
    (v) (-v) (+v) {
      quote mode $chan +v $nick}
    (k) (-k) (+k) {
      quote kick $chan $nick :${[$1] ? [$1-] : getreason($nick)}}
    (bk) (kb) (-bk) (-kb) (+bk) (+kb) {
      bk $chan $nick ${[$1] ? [$1-] : getreason($nick)}}
    () (*) {
      pusage lj}}} else {
    ce no joins to $chan yet.}}

# ..more stuff
alias license {
  more $HOME/.parallax/LICENSE}

alias changes {
  more $HOME/.parallax/CHANGES}

# ..sjk'98
